Subject: [bug#40365] [PATCH] guix: Improve docstring of wrap-program.

From: Christopher Baines <[email-masked]>
Date: Sat, 21 Nov 2020 10:17:52 +0000

Brendan Tildesley <[email-masked]> writes:

> * guix/build/utils.scm (wrap-progran): Add an explanation for POSITION. Change
> 'DIRECTORIES' to 'VALUES' since an environment variable might not only be
> paths.'
> ---
>  guix/build/utils.scm | 16 ++++++++++++----
>  1 file changed, 12 insertions(+), 4 deletions(-)

Thanks Brendan, and apologies that it's taken a while to review this.

I made some tweaks to end up with this:

 (define* (wrap-program prog #:rest vars)
-  "Make a wrapper for PROG.  VARS should look like this:
+  "Make a wrapper for PROG.  VARS is a list of lists that should look like this:

-  '(VARIABLE DELIMITER POSITION LIST-OF-DIRECTORIES)
+  '(VARIABLE DELIMITER POSITION LIST-OF-VALUES)

 where DELIMITER is optional.  ':' will be used if DELIMITER is not given.

+POSITION is a symbol, either =, prefix, or suffix that selects how the
+LIST-OF-VALUES are consolidated with the value of VARIABLE at the time the
+wrapped program is run.  prefix and suffix each result in including values
+from the users environment either before or after LIST-OF-VALUES respectively,
+whereas = replaces any existing value for VARIABLE.  It is important to
+understand how each variable is used by the program so that the correct choice
+can be made.
+

I'll hopefully describe why below. Anyway, let me know what you think,
I'm happy to push some improvements to this.

There's a bit of a cost to updating this file, since I believe changing
it will effectively trigger every Guix package's derivation to change,
hence it will need to be done on the core-updates branch.

> diff --git a/guix/build/utils.scm b/guix/build/utils.scm
> index b8be73ead4..ba4d1d8657 100644
> --- a/guix/build/utils.scm
> +++ b/guix/build/utils.scm
> @@ -5,6 +5,7 @@
>  ;;; Copyright © 2015, 2018 Mark H Weaver <[email-masked]>
>  ;;; Copyright © 2018 Arun Isaac <[email-masked]>
>  ;;; Copyright © 2018, 2019 Ricardo Wurmus <[email-masked]>
> +;;; Copyright © 2020 Brendan Tildesley <[email-masked]>
>  ;;;
>  ;;; This file is part of GNU Guix.
>  ;;;
> @@ -1114,13 +1115,20 @@ known as `nuke-refs' in Nixpkgs."
>                (string-suffix? "-real" base)))))
>
>  (define* (wrap-program prog #:rest vars)
> -  "Make a wrapper for PROG.  VARS should look like this:
> +  "Make a wrapper for PROG.  VARS is a list of lists that should look like this:

I'm not sure I'd describe vars as a list of lists, I think I see what
you're getting at, in that there can be more than one thing in vars, but
from the perspective of a user of this procedure, you don't pass in a
list of list, just one or more arguments at the end.

>
> -  '(VARIABLE DELIMITER POSITION LIST-OF-DIRECTORIES)
> +  '(VARIABLE DELIMITER POSITION LIST-OF-VALUES)
>
>  where DELIMITER is optional.  ':' will be used if DELIMITER is not given.
> -
> -For example, this command:
> +POSITION is a Scheme symbol of either =, prefix, or suffix that selects how
> +the export VARIABLE line is formatted.  prefix and suffix each result in

Rather than talking about formatting here, I tried to say something
about "consolidation", although maybe that's too complicated.

> +including values from the users environment either after or before VALUE,
> +whereas = overshadows any existing value, preventing the users environment
> +from 'infecting' the wrapped programs environment.  It is important to
> +understand how each variable is used by the program so that the correct choice
> +can be made.  Otherwise, the program could malfunction in unexpected ways on a
> +different persons computer due to a difference in the inherited environment
> +variables.  For example, this command:

I'm not sure about including this "Otherwise ..." bit, I think what you
say prior is sufficient.

>
>    (wrap-program \"foo\"
>                  '(\"PATH\" \":\" = (\"/gnu/.../bar/bin\"))

Thanks again,

Chris